program hexxagon;
{ UJA 1.00, im Hau-Ruck-Verfahren von hinten bis vorne am 19.11.1995 }

uses graph,intuit,crt,dos;

const xmax=32; ymax=16; dx=16; dy=24; ox=32; oy=16; lsize=256;
      levelfile='hexarev.l';
      imafile  ='hexxa.ima';

type feld  = array[-1..xmax+2,-1..ymax+2] of integer;
     liste = array[0..lsize,0..1] of integer;

var level,i,j,g,mx,my,xx,yy,dran,notdran,x,y,count1,count2,anz,power:integer;
    f                    :feld;
    l1,l2                :liste;
    ima                  :array[1..6] of image;
    igad                 :array[1..6] of gadget;
    itext1,itext2,itext3 :array[1..8] of IntuiText;
    ibord1,ibord2,ibord3 :array[1..6] of Border;
    xy1,xy2,xy3,xy4      :koords;
    ok,ende,fini,hilfe   :boolean;
    ch                   :char;
    temp,lname           :string;
    punkte               :array[1..2] of integer;
    compi                :array[1..2] of boolean;

{ --- }

procedure setzefarben;
const cmap0:array [0..15,0..2] of integer = (
(  0,  0,  0),( 31, 19, 25),( 37, 24, 29),( 43, 30, 33),
( 50, 36, 37),( 56, 44, 43),( 63, 54, 51),( 63, 63, 55),
( 39, 57, 55),( 36, 49, 50),( 34, 43, 46),( 32, 37, 40),
( 27, 29, 34),( 22, 22, 27),( 18, 17, 20),( 23, 21, 22));

const cmap:array[0..15,0..2] of integer = (
(  0,  0,  0),( 31, 18,  0),( 41, 24,  0),( 52, 31,  0),
( 63, 40,  0),( 63, 46, 28),( 63, 54, 41),( 20, 6, 7),
( 29, 60, 57),(  0, 57, 51),(  0, 49, 46),(  0, 42, 41),
(  0, 34, 34),(  0, 26, 27),(  0, 18, 20),( 63, 63, 63));

var i,j:integer;
begin
for i:=0 to 15 do begin
   setrgbpalette(i,cmap[i,0],cmap[i,1],cmap[i,2]);
   setpalette(i,i);
end;
end;

{ --- }

procedure initstructures;
var i,size,gelesen:integer;
    f             :file;
begin
   assign(f,imafile);
   reset(f,1);
   for i:=1 to 6 do begin
   blockread(f,ima[i],sizeof(image));
   with ima[i] do begin
      size:=imagesize(1,1,width,height);
      getmem(p_data,size);
      blockread(f,p_data^,size,gelesen);
   end;
   end;
   close(f);

   itext1[1].itext:='Aussetzen';
   itext1[2].itext:='  N e u  ';
   itext1[3].itext:='L e v e l';
   itext1[4].itext:='Q u i t  ';
   itext1[5].itext:='Spieler 1:  xxxxx Punkte';
   itext1[6].itext:='Spieler 2:  xxxxx Punkte';
   itext1[7].itext:='----  b y   U J A  -----';

   for i:=1 to 7 do with itext1[i] do begin
      x:=13;
      y:=4;
      fpen:=15;
      bpen:=12;
      drmode:=jam1;
      p_nexttext:=addr(itext2[i]);
   end;
   for i:=1 to 7 do with itext2[i] do begin
      x:=11;
      y:=4;
      fpen:=0;
      bpen:=12;
      drmode:=jam1;
      itext:=itext1[i].itext;
      p_nexttext:=addr(itext3[i]);
   end;
    for i:=1 to 7 do with itext3[i] do begin
      x:=12;
      y:=itext1[i].y;
      fpen:=7;
      bpen:=itext1[i].bpen;
      drmode:=jam1;
      itext:=itext1[i].itext;
      p_nexttext:=nil;
   end;
   itext3[5].fpen:=12;
   itext3[6].fpen:=3;

   xy1[0]:=0;  xy1[1]:=0;      xy1[2]:=95;     xy1[3]:=xy1[1]; xy1[4]:=xy1[2];
   xy1[5]:=15; xy1[6]:=xy1[0]; xy1[7]:=xy1[5]; xy1[8]:=xy1[0]; xy1[9]:=xy1[1];
   xy2[0]:=1; xy2[1]:=14; xy2[2]:=xy2[0];
   xy2[3]:=1; xy2[4]:=94; xy2[5]:=xy2[3];
   xy3[0]:=1;      xy3[1]:=14;     xy3[2]:=94;
   xy3[3]:=xy3[1]; xy3[4]:=xy3[2]; xy3[5]:=xy3[0];

   for i:=1 to 4 do begin
   with ibord1[i] do begin
      x:=0; y:=0; fpen:=0; bpen:=12; drmode:=jam1; ecken:=5;
      p_ecken:=addr(xy1);
      p_nextborder:=addr(ibord2[i]);
   end;
   with ibord2[i] do begin
      x:=0; y:=0; fpen:=15; bpen:=12; drmode:=jam1; ecken:=3;
      p_ecken:=addr(xy2);
      p_nextborder:=addr(ibord3[i]);
   end;
   with ibord3[i] do begin
      x:=0; y:=0; fpen:=2; bpen:=12; drmode:=jam1; ecken:=3;
      p_ecken:=addr(xy3);
      p_nextborder:=nil;
   end;
   end;

   for i:=1 to 4 do with igad[i] do begin
      id:=i; x:=152+i*96; y:=460; width:=96; height:=16; bpen:=5; hibpen:=12;
      p_loborder:=addr(ibord1[i]); p_hiborder:=p_loborder;
      p_loimage:=nil; p_hiimage:=nil;
      p_lointuitext:=addr(itext1[i]); p_hiintuitext:=p_lointuitext;
      onoff:=false; active:=true;
      p_nextgadget:=addr(igad[succ(i)]);
   end;

   i:=5; with igad[i] do begin
      id:=i; x:=ox+dx; y:=oy+dy; width:=dx*xmax; height:=dy*ymax;
      bpen:=-1; hibpen:=-1;
      p_loborder:=nil; p_hiborder:=p_loborder;
      p_loimage:=nil; p_hiimage:=nil;
      p_lointuitext:=nil; p_hiintuitext:=p_lointuitext;
      onoff:=false; active:=true;
      p_nextgadget:=nil;
   end;
end;

{ --- }

procedure zeichnefeld;
var i :integer;
    t1:string;
begin
   rectfill(0,0,639,479,7);
   rectfill(6,6,632,24,0);
   rectfill(8,8,630,22,5);
   setcolor(15);
   line(7,7,631,7);
   line(7,7,7,23);
   setcolor(0);
   line(631,8,631,23);
   line(7,23,631,23);

   t1:='U J A s   H e x x a g o n    -    TP6  V. 1.00    (c) uja 11/95';
   setcolor(15); outtextxy(82,12,t1);
   setcolor(0); outtextxy(80,12,t1);
   setcolor(7); outtextxy(81,12,t1);

   for i:=1 to 4 do DrawGadget(addr(igad[i]));

end;

{ --- }

procedure updatpunkte;
var t1,t2:string;
begin
   for i:=1 to 2 do begin
      str(i:2,t1);
      str(punkte[i]:6,t2);
      itext1[4+i].itext:='Spieler'+t1+': '+t2+' Punkte';
      itext2[4+i].itext:=itext1[4+i].itext;
      itext3[4+i].itext:=itext1[4+i].itext;
   end;

   rectfill(8,440,239,475,7);
   setcolor(15);
   line(8,440,239,440);
   line(8,440,8,475);
   setcolor(0);
   line(8,475,239,475);
   line(239,441,239,475);
   DrawIntuiText(16,442,addr(itext1[5]));
   DrawIntuiText(16,458,addr(itext1[6]));
end;

{ --- }

procedure messi(t1:string; c:integer);
begin
   itext1[7].itext:=t1;
   itext2[7].itext:=itext1[7].itext;
   itext3[7].itext:=itext1[7].itext;
   case c of
   0: itext3[7].fpen:=14;
   1: itext3[7].fpen:=12;
   2: itext3[7].fpen:= 3;
   end;

   rectfill(248,440,631,455,7);
   setcolor(15);
   line(248,440,631,440);
   line(248,440,248,455);
   setcolor(0);
   line(248,455,631,455);
   line(631,441,631,455);
   DrawIntuiText(260,442,addr(itext1[7]));
end;

{ --- }

procedure ladelevel(var level:integer; var lname:string;
                    var f:feld; var anz:integer);
const code:string='12 #';
var temp:string;
    fh:text;
    i,j,k:integer;
    ok:boolean;
begin
anz:=0;
for i:=1 to xmax do for j:=1 to ymax do f[i,j]:=0;

str(level:2,temp);
if level<10 then temp[1]:='0';
temp:=levelfile+temp;
{$i-}
assign(fh,temp);
reset(fh);
ok:=ioresult=0;
if ok then readln(fh,lname) else lname:='Star';
for j:=1 to ymax do begin
   if ok then readln(fh,temp) else
   case j of
    3: temp:='        # # # # #';
    4: temp:='       #   # #   #';
    5: temp:='      # # # # # # #';
    6: temp:='     # # # 1 2 # # #';
    7: temp:='    #   1 2   1 2   #';
    8: temp:='     # # # 1 2 # # #';
    9: temp:='      # # # # # # #';
   10: temp:='       #   # #   #';
   11: temp:='        # # # # #';
   else temp:='';
   end;
   for i:=1 to length(temp) do begin
      f[i,j]:=pos(temp[i],code);
      if f[i,j] =3 then f[i,j]:=0;
      if f[i,j]=4 then inc(anz);
   end;
end;
if ok then close(fh) else level:=0;
end;

{ --- }

procedure drawfeld;
var i,j:integer;
begin
   rectfill(ox+dx,oy+dy,ox+succ(xmax)*dx,oy+succ(ymax)*dy,7);
   for i:=1 to 2 do punkte[i]:=0;
   for j:=1 to ymax do for i:=1 to xmax do begin
      case f[i,j] of
      1,2: begin
              DrawImage(i*dx+ox,j*dy+oy,addr(ima[succ(f[i,j])]));
              inc(punkte[f[i,j]]);
           end;
        4: DrawImage(i*dx+ox,j*dy+oy,addr(ima[1]));
      end;
   end;
end;

{ --- }

procedure auswertung(var x,y,dran,notdran,count:integer;
                     var l:liste; var f:feld);
{ checkt ab, ob Punkte zu machen sind, geschlagene Figuren in l }
{ Eingangsbedingung: Feld ist leer }
var i,j,k        :integer;
    ok,stopit    :boolean;
begin
   count:=0;

   { rechts pruefen: }
   i:=x+2;
   k:=count;
   if f[i,y]=notdran then repeat
      k:=succ(k);
      l[k,0]:=i;
      l[k,1]:=y;
      i:=i+2;
      ok:=f[i,y]=dran;
      stopit:=f[i,y]<>notdran;
   until ok or stopit;
   if ok then count:=k;

   { rechts oben pruefen: }
   i:=x+1;
   j:=y-1;
   k:=count;
   if f[i,j]=notdran then repeat
      k:=succ(k);
      l[k,0]:=i;
      l[k,1]:=j;
      i:=i+1;
      j:=j-1;
      ok:=f[i,j]=dran;
      stopit:=f[i,j]<>notdran;
   until ok or stopit;
   if ok then count:=k;

   { rechts unten pruefen: }
   i:=x+1;
   j:=y+1;
   k:=count;
   if f[i,j]=notdran then repeat
      k:=succ(k);
      l[k,0]:=i;
      l[k,1]:=j;
      i:=i+1;
      j:=j+1;
      ok:=f[i,j]=dran;
      stopit:=f[i,j]<>notdran;
   until ok or stopit;
   if ok then count:=k;


   { links pruefen:  }
   i:=x-2;
   k:=count;
   if f[i,y]=notdran then repeat
      k:=succ(k);
      l[k,0]:=i;
      l[k,1]:=y;
      i:=i-2;
      ok:=f[i,y]=dran;
      stopit:=f[i,y]<>notdran;
   until ok or stopit;
   if ok then count:=k;

   { links oben pruefen: }
   i:=x-1;
   j:=y-1;
   k:=count;
   if f[i,j]=notdran then repeat
      k:=succ(k);
      l[k,0]:=i;
      l[k,1]:=j;
      i:=i-1;
      j:=j-1;
      ok:=f[i,j]=dran;
      stopit:=f[i,j]<>notdran;
   until ok or stopit;
   if ok then count:=k;

   { links unten pruefen: }
   i:=x-1;
   j:=y+1;
   k:=count;
   if f[i,j]=notdran then repeat
      k:=succ(k);
      l[k,0]:=i;
      l[k,1]:=j;
      i:=i-1;
      j:=j+1;
      ok:=f[i,j]=dran;
      stopit:=f[i,j]<>notdran;
   until ok or stopit;
   if ok then count:=k;

end;

procedure zugchecken(var dran,notdran,l:integer; var l2:liste; var f:feld);
{ checkt alle moeglichen zuege }
var i,j,k:integer;
begin
   l:=0;
   for i:=1 to xmax do for j:=1 to ymax do if f[i,j]=4 then begin
      auswertung(i,j,dran,notdran,k,l1,f);
      if k>0 then begin
         inc(l);
         l2[l,0]:=i;
         l2[l,1]:=j;
      end;
   end;
end;


procedure aussetzen(var dran,notdran:integer);
var i,j,k,l:integer;
begin
   zugchecken(dran,notdran,l,l2,f);
   if l=0 then begin
      notdran:=dran;
      dran:=succ(dran mod 2);
   end else begin
      sound(50);
      messi('Du kannst noch setzen!',dran);
      delay(100);
      nosound;
      delay(900);
      for k:=1 to 3 do begin
         delay(200);
         for i:=1 to l do 
         DrawImage(l2[i,0]*dx+ox,l2[i,1]*dy+oy,addr(ima[succ(dran)]));
         delay(200);
         for i:=1 to l do 
         DrawImage(l2[i,0]*dx+ox,l2[i,1]*dy+oy,addr(ima[1]));
      end;
   end;
end;


procedure gameloop(var mx,my,dran,notdran,anz:integer);
var i,j,k,x,y,z:integer;
    ok         :boolean;
begin
   x:=(mx-ox) div dx;
   y:=(my-oy) div dy;
   ok:=f[x,y]=4;
   if not ok then begin
      dec(x);
      ok:=f[x,y]=4;
   end;

   if ok then begin
      auswertung(x,y,dran,notdran,count1,l1,f);
      if count1>0 then begin
         punkte[dran]:=punkte[dran]+count1+1;
         punkte[notdran]:=punkte[notdran]-count1;
         DrawImage(x*dx+ox,y*dy+oy,addr(ima[succ(dran)]));
         f[x,y]:=dran;
         delay(500);
         for i:=1 to count1 do begin
            f[l1[i,0],l1[i,1]]:=dran;
            DrawImage(l1[i,0]*dx+ox,l1[i,1]*dy+oy,addr(ima[succ(dran+2)]));
         end;
         updatpunkte;
         notdran:=dran;
         dran:=succ(dran mod 2);
      end else begin
         sound(50);
         messi('ungltiger Zug',dran);
         delay(100);
         nosound;
         delay(900);
      end;
   end;
end;


procedure initlevel(var level:integer);
begin
ladelevel(level,lname,f,anz);
drawfeld;
itext1[3].itext:=lname;
itext2[3].itext:=lname;
itext3[3].itext:=lname;
DrawGadget(addr(igad[3]));

updatpunkte;
dran:=1;
notdran:=2;
fini:=false;

end;

{ === }

procedure setzen(var f:feld; var x,y,dran,notdran:integer);
var i,count:integer;
begin
f[x,y]:=dran;
auswertung(x,y,dran,notdran,count,l1,f);
for i:=1 to count do f[l1[i,0],l1[i,1]]:=dran;
end;


procedure getmax(var dran,notdran,x,y,tiefe:integer; var f0:feld);
var l                        :liste;
    f                        :feld;
    i,xx,yy,max,ges,anz,s1   :integer;
begin
   x:=0;
   y:=0;
   zugchecken(dran,notdran,anz,l,f0);
   if anz>0 then begin
      max:=-9999;
      for i:=1 to anz do begin
         f:=f0;
         setzen(f,l[i,0],l[i,1],dran,notdran);
         s1:=tiefe-1;
         if tiefe>1 then getmax(notdran,dran,xx,yy,s1,f);
         s1:=0;
         for xx:=1 to xmax do for yy:=1 to ymax do begin
            if f[xx,yy]=dran then inc(s1);
            if f[xx,yy]=notdran then dec(s1);
         end;
         if s1>max then begin
            x:=l[i,0];
            y:=l[i,1];
            max:=s1;
         end;
      end;
   end;
end;


{ === }

begin
for i:=1 to 2 do compi[i]:=false;
TextColor(white);
TextBackground(cyan);
write(' ͻ ');
TextBackground(black);
writeln;
TextBackground(cyan);

write('   UJAs HexaReversi V1.00                TP6.01                    ');
TextBackground(black);
writeln;
TextBackground(cyan);
write(' ͼ ');
TextBackground(black);
writeln;
TextColor(yellow);
writeln;
write(' Spieler1: [C]omputer oder [M]ensch? ');
ch:=readkey; compi[1]:=ch in['C','c'];
if compi[1] then writeln('---> Compi') else writeln('---> Mensch');
if not compi[1] then begin
   write(' Spieler2: [C]omputer oder [M]ensch? ');
   ch:=readkey; compi[2]:=ch in['C','c'];
   if compi[2] then writeln('---> Compi') else writeln('---> Mensch');
end;

if compi[1] or compi[2] then begin
   write(' Spielstrke [ 1 - 4 ] ?             ');
   ch:=readkey;
   power:=ord(ch)-48;
   if power<1 then power:=1;
   if power>6 then power:=6;
   writeln('---> ',power:1);
end;

write('welches Brett  [ 0 - 7 ] ?           ');
ch:=readkey;
level:=ord(ch)-48;
writeln('---> Brett ',level:1);
delay(500);

initscreen(ok);
if ok then begin
   setzefarben;
   initstructures;
   zeichnefeld;
   ende:=false;
   initlevel(level);

   while not ende do begin

      if (not fini) and compi[dran] then begin
         messi('... ich grbele...',dran);
         getmax(dran,notdran,x,y,power,f);
         if x=0 then begin
            messi('... ich mu aussetzen... ',dran);
            notdran:=dran;
            dran:=succ(dran mod 2);
            zugchecken(dran,notdran,i,l2,f);
            fini:=(i=0);
         end else begin
            DrawImage(x*dx+ox,y*dy+oy,addr(ima[6]));
            messi('... ich setze ...',dran);
            f[x,y]:=dran;
            auswertung(x,y,dran,notdran,count1,l1,f);
            punkte[dran]:=punkte[dran]+count1+1;
            punkte[notdran]:=punkte[notdran]-count1;
            DrawImage(x*dx+ox,y*dy+oy,addr(ima[succ(dran)]));
            f[x,y]:=dran;
            delay(500);
            for i:=1 to count1 do begin
               f[l1[i,0],l1[i,1]]:=dran;
               DrawImage(l1[i,0]*dx+ox,l1[i,1]*dy+oy,addr(ima[succ(dran+2)]));
            end;
            updatpunkte;
            notdran:=dran;
            dran:=succ(dran mod 2);
         end;

      end else begin
         zugchecken(dran,notdran,i,l2,f);
         if i>0 then begin
            messi('... bitte setzen...',dran);
            gadgetup(addr(igad[1]),g,mx,my);
            case g of
            1: aussetzen(dran,notdran);
            2: initlevel(level);
            3: begin
               inc(level);
               initlevel(level);
               end;
            4: ende:=true;
            5: begin
               gameloop(mx,my,dran,notdran,anz);
               zugchecken(dran,notdran,i,l2,f);
               fini:=i=0;
               if fini then begin
                  notdran:=dran;
                  dran:=succ(dran mod 2);
                  zugchecken(dran,notdran,i,l2,f);
                  fini:=fini and (i=0);
               end;
               end;
            end;  { case    }
         end else begin
            messi('Du mut aussetzen',dran);
            notdran:=dran;
            dran:=succ(dran mod 2);
         end;

      end;     { Mensch  }

      if fini then begin
         messi('--- by UJA ---',0);
         for i:=1 to 5 do begin
            for y:=1 to ymax do for x:=1 to xmax do
            if f[x,y] in [1,2] then
            DrawImage(x*dx+ox,y*dy+oy,addr(ima[f[x,y]+3]));
            delay(10);
            for y:=1 to ymax do for x:=1 to xmax do
            if f[x,y] in [1,2] then
            DrawImage(x*dx+ox,y*dy+oy,addr(ima[succ(f[x,y])]));
            delay(10);
         end;
         repeat
         gadgetup(addr(igad[1]),g,mx,my);
         case g of
         2: initlevel(level);
         3: begin
               inc(level);
               initlevel(level);
            end;
         4: ende:=true;
         end;
         until g in [2..4];
      end;

   end;          { while not ende }
end;             { if ok }

textmode(3);
end.
           
